diff --git a/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java b/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java
index 64e3ddd39..825a17084 100644
--- a/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java
+++ b/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java
@@ -2167,66 +2020,66 @@ public class RenderGlobal
                 int xOff = direction.getOffsetX();
                 int yOff = direction.getOffsetY();
                 int zOff = direction.getOffsetZ();
-                double px = (double)x + (double)xOff * 0.6D + 0.5D;
-                double py = (double)y + (double)yOff * 0.6D + 0.5D;
-                double pz = (double)z + (double)zOff * 0.6D + 0.5D;
-                for(int i = 0; i < 10; i++) {
+                double px = (double) x + (double) xOff * 0.6D + 0.5D;
+                double py = (double) y + (double) yOff * 0.6D + 0.5D;
+                double pz = (double) z + (double) zOff * 0.6D + 0.5D;
+                for (int i = 0; i < 10; i++) {
                     double rO = random.nextDouble() * 0.2D + 0.01D;
-                    double fx = px + (double)xOff * 0.01D + (random.nextDouble() - 0.5D) * (double)zOff * 0.5D;
-                    double fy = py + (double)yOff * 0.01D + (random.nextDouble() - 0.5D) * (double)yOff * 0.5D;
-                    double fz = pz + (double)zOff * 0.01D + (random.nextDouble() - 0.5D) * (double)xOff * 0.5D;
-                    double mx = (double)xOff * rO + random.nextGaussian() * 0.01D;
-                    double my = (double)yOff * rO + random.nextGaussian() * 0.01D;
-                    double mz = (double)zOff * rO + random.nextGaussian() * 0.01D;
+                    double fx = px + (double) xOff * 0.01D + (random.nextDouble() - 0.5D) * (double) zOff * 0.5D;
+                    double fy = py + (double) yOff * 0.01D + (random.nextDouble() - 0.5D) * (double) yOff * 0.5D;
+                    double fz = pz + (double) zOff * 0.01D + (random.nextDouble() - 0.5D) * (double) xOff * 0.5D;
+                    double mx = (double) xOff * rO + random.nextGaussian() * 0.01D;
+                    double my = (double) yOff * rO + random.nextGaussian() * 0.01D;
+                    double mz = (double) zOff * rO + random.nextGaussian() * 0.01D;
                     addParticle("smoke", fx, fy, fz, mx, my, mz, 0);
                 }
 
                 break;
 
             case EVENT_BLOCK_BREAK: // Block break effect
-                if(data > 0) {
+                if (data > 0) {
                     Block<?> block = Blocks.blocksList[data];
 
-                    world.playBlockSoundEffect(null, (float)x + 0.5F, (float)y + 0.5F, (float)z + 0.5F, block, EnumBlockSoundEffectType.MINE);
+                    world.playBlockSoundEffect(null, (float) x + 0.5F, (float) y + 0.5F, (float) z + 0.5F, block, EnumBlockSoundEffectType.MINE);
                 }
                 mc.particleEngine.destroy(x, y, z, data, world.getBlockMetadata(x, y, z));
                 break;
 
             case EVENT_DOOR_SOUND: // Door sound
-                if(java.lang.Math.random() < 0.5D) {
-                    world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, (double)x + 0.5D, (double)y + 0.5D, (double)z + 0.5D, "random.door_open", 1.0F, world.rand.nextFloat() * 0.1F + 0.9F);
+                if (java.lang.Math.random() < 0.5D) {
+                    world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, (double) x + 0.5D, (double) y + 0.5D, (double) z + 0.5D, "random.door_open", 1.0F, world.rand.nextFloat() * 0.1F + 0.9F);
                 } else {
-                    world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, (double)x + 0.5D, (double)y + 0.5D, (double)z + 0.5D, "random.door_close", 1.0F, world.rand.nextFloat() * 0.1F + 0.9F);
+                    world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, (double) x + 0.5D, (double) y + 0.5D, (double) z + 0.5D, "random.door_close", 1.0F, world.rand.nextFloat() * 0.1F + 0.9F);
                 }
                 break;
 
             case EVENT_FIRE_EXTINGUISH: // Fire extinguish sound
-                world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, (float)x + 0.5F, (float)y + 0.5F, (float)z + 0.5F, "random.fizz", 0.5F, 2.6F + (random.nextFloat() - random.nextFloat()) * 0.8F);
+                world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, (float) x + 0.5F, (float) y + 0.5F, (float) z + 0.5F, "random.fizz", 0.5F, 2.6F + (random.nextFloat() - random.nextFloat()) * 0.8F);
                 break;
 
             case EVENT_JUKEBOX_TOGGLE: // Jukebox play/stop record
-                if(Item.itemsList[data] instanceof ItemDiscMusic) {
-                    ItemDiscMusic record = ((ItemDiscMusic)Item.itemsList[data]);
+                if (Item.itemsList[data] instanceof ItemDiscMusic) {
+                    ItemDiscMusic record = ((ItemDiscMusic) Item.itemsList[data]);
                     world.playRecord(record.recordName, record.recordAuthor, x, y, z);
                 } else {
                     world.playRecord(null, null, x, y, z);
                 }
                 break;
             case EVENT_PISTON_EXTEND: // Piston extend
-                world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, (double)x + 0.5F, (double)y + 0.5F, (double)z + 0.5F, "tile.piston.out", 0.5F, world.rand.nextFloat() * 0.25F + 0.6F);
+                world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, (double) x + 0.5F, (double) y + 0.5F, (double) z + 0.5F, "tile.piston.out", 0.5F, world.rand.nextFloat() * 0.25F + 0.6F);
                 break;
             case EVENT_PISTON_RETRACT: // Piston retract
-                world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, (double)x + 0.5F, (double)y + 0.5F, (double)z + 0.5F, "tile.piston.in", 0.5F, world.rand.nextFloat() * 0.25F + 0.6F);
+                world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, (double) x + 0.5F, (double) y + 0.5F, (double) z + 0.5F, "tile.piston.in", 0.5F, world.rand.nextFloat() * 0.25F + 0.6F);
                 break;
         }
     }
-    
-	@Override
-	public void entityAdded(Entity entity) {
-	}
-
-	@Override
-	public void entityRemoved(Entity entity) {
-	}
+
+    @Override
+    public void entityAdded(Entity entity) {
+    }
+
+    @Override
+    public void entityRemoved(Entity entity) {
+    }
 
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/terrain/ChunkRenderer.java b/game/client/src/main/java/net/minecraft/client/render/terrain/ChunkRenderer.java
index 0fd4bcdfc..17cc19e67 100644
--- a/game/client/src/main/java/net/minecraft/client/render/terrain/ChunkRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/terrain/ChunkRenderer.java
@@ -96,7 +96,7 @@ public abstract class ChunkRenderer
         }
     }
     
-    public abstract void rebuild();
+    public abstract boolean rebuild(boolean priority);
     
     public boolean renderBlock(Tessellator tessellator, WorldSource worldSource, BlockModel<?> model, int x, int y, int z) {
     	boolean rendered = false;
@@ -163,7 +163,7 @@ public abstract class ChunkRenderer
 
     public void cull(CameraFrustum frustum, float partialTick)
     {
-        visible = frustum.isVisible(bb, partialTick);
+        visible = true/*frustum.isVisible(bb, partialTick)*/;
     }
 
     public void renderBB()
diff --git a/game/client/src/main/java/net/minecraft/client/render/terrain/ChunkRendererLegacy.java b/game/client/src/main/java/net/minecraft/client/render/terrain/ChunkRendererLegacy.java
index 9691b5268..0d40a5209 100644
--- a/game/client/src/main/java/net/minecraft/client/render/terrain/ChunkRendererLegacy.java
+++ b/game/client/src/main/java/net/minecraft/client/render/terrain/ChunkRendererLegacy.java
@@ -7,6 +7,7 @@ import java.util.Set;
 import net.minecraft.client.render.block.model.BlockModelDispatcher;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.world.pos.TilePos;
 import org.lwjgl.opengl.GL11;
 
 import net.minecraft.client.render.TileEntityRenderDispatcher;
@@ -24,23 +25,27 @@ public class ChunkRendererLegacy extends ChunkRenderer {
 	}
 
 	@Override
-    public void rebuild()
+    public boolean rebuild(boolean priority)
     {
-        if(!dirty) { return; }
-        updates++;
+        if(!dirty) { return false; }
         final int minX = posX;
         final int minY = posY;
         final int minZ = posZ;
         final int maxX = posX + sizeX;
         final int maxY = posY + sizeY;
         final int maxZ = posZ + sizeZ;
+
+        final int cacheRadius = 1;
+        final ChunkCache chunkcache = new ChunkCache(world, new TilePos(minX - cacheRadius, minY - cacheRadius, minZ - cacheRadius), new TilePos(maxX + cacheRadius, maxY + cacheRadius, maxZ + cacheRadius), priority);
+        if (!chunkcache.allLoaded()) return false;
+
         for(int i = 0; i < MAX_RENDER_PASSES; i++) { empty[i] = true; }
 
         Chunk.isLit = false;
         final Set<TileEntity> lastSpecialTileEntities = new HashSet<>(renderableBlockEntities);
         renderableBlockEntities.clear();
-        final int cacheRadius = 1;
-        final ChunkCache chunkcache = new ChunkCache(world, minX - cacheRadius, minY - cacheRadius, minZ - cacheRadius, maxX + cacheRadius, maxY + cacheRadius, maxZ + cacheRadius);
+        updates++;
+
         int renderPass = 0;
         Tessellator tessellator = Tessellator.instance;
         do
@@ -125,6 +130,7 @@ public class ChunkRendererLegacy extends ChunkRenderer {
         globalRenderableBlockEntities.removeAll(lastSpecialTileEntities);
         skyLit = Chunk.isLit;
         compiled = true;
+        return true;
     }
 
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/terrain/ChunkRendererMultiDraw.java b/game/client/src/main/java/net/minecraft/client/render/terrain/ChunkRendererMultiDraw.java
index 183ece731..bd8c5a664 100644
--- a/game/client/src/main/java/net/minecraft/client/render/terrain/ChunkRendererMultiDraw.java
+++ b/game/client/src/main/java/net/minecraft/client/render/terrain/ChunkRendererMultiDraw.java
@@ -17,6 +17,7 @@ import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.chunk.Chunk;
 import net.minecraft.core.world.chunk.ChunkCache;
+import net.minecraft.core.world.pos.TilePos;
 
 public class ChunkRendererMultiDraw extends ChunkRenderer {
 
@@ -35,13 +36,11 @@ public class ChunkRendererMultiDraw extends ChunkRenderer {
 	}
 	
 	@Override
-	public void rebuild() {
+	public boolean rebuild(boolean priority) {
 		if(!dirty) {
-			return;
+			return false;
 		}
 		
-		updates++;
-		
 		final int minX = posX;
 		final int minY = posY;
 		final int minZ = posZ;
@@ -51,15 +50,17 @@ public class ChunkRendererMultiDraw extends ChunkRenderer {
 		final int maxZ = posZ + sizeZ;
 		
 		final int renderPassCount = terrainRenderer.MAX_RENDER_PASSES;
-		
+
+		final int cacheRadius = 1;
+		final ChunkCache chunkCache = new ChunkCache(world, new TilePos(minX - cacheRadius, minY - cacheRadius, minZ - cacheRadius), new TilePos(maxX + cacheRadius, maxY + cacheRadius, maxZ + cacheRadius), priority);
+		if (!chunkCache.allLoaded()) return false;
+
 		terrainRenderer.chunkDeleted(this);
-		
 		Chunk.isLit = false;
 		final Set<TileEntity> lastSpecialTileEntities = new HashSet<>(renderableBlockEntities);
 		renderableBlockEntities.clear();
-		
-		final int cacheRadius = 1;
-		final ChunkCache chunkCache = new ChunkCache(world, minX - cacheRadius, minY - cacheRadius, minZ - cacheRadius, maxX + cacheRadius, maxY + cacheRadius, maxZ + cacheRadius);
+
+		updates++;
 
 		TessellatorStandard tessellator = (TessellatorStandard) Tessellator.instance;
 		for(int renderPass = 0; renderPass < renderPassCount; renderPass++) {
@@ -129,6 +130,7 @@ public class ChunkRendererMultiDraw extends ChunkRenderer {
 		globalRenderableBlockEntities.removeAll(lastSpecialTileEntities);
 		skyLit = Chunk.isLit;
 		compiled = true;
+		return true;
 	}
 	
 	@Override
diff --git a/game/client/src/main/java/net/minecraft/client/render/terrain/RegionBuffer.java b/game/client/src/main/java/net/minecraft/client/render/terrain/RegionBuffer.java
index af39ef45d..5b11603b8 100644
--- a/game/client/src/main/java/net/minecraft/client/render/terrain/RegionBuffer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/terrain/RegionBuffer.java
@@ -2,6 +2,7 @@ package net.minecraft.client.render.terrain;
 
 import it.unimi.dsi.fastutil.ints.Int2ObjectArrayMap;
 import it.unimi.dsi.fastutil.ints.Int2ObjectMap;
+import it.unimi.dsi.fastutil.ints.Int2ObjectOpenHashMap;
 
 import java.util.ArrayList;
 import java.util.Collections;
@@ -13,7 +14,7 @@ public class RegionBuffer {
 	
 	public final int regionSizeShift;
 	
-	private final Int2ObjectMap<RenderRegion> regionMap = new Int2ObjectArrayMap<>();
+	private final Int2ObjectMap<RenderRegion> regionMap = new Int2ObjectOpenHashMap<>();
 	private final List<RenderRegion> regionList = new ArrayList<>();
 	private final List<RenderRegion> immutableRegionList = Collections.unmodifiableList(regionList);
 	
diff --git a/game/client/src/main/java/net/minecraft/client/util/dispatch/Dispatcher.java b/game/client/src/main/java/net/minecraft/client/util/dispatch/Dispatcher.java
index 9503d913b..59448f612 100644
--- a/game/client/src/main/java/net/minecraft/client/util/dispatch/Dispatcher.java
+++ b/game/client/src/main/java/net/minecraft/client/util/dispatch/Dispatcher.java
@@ -1,5 +1,7 @@
 package net.minecraft.client.util.dispatch;
 
+import it.unimi.dsi.fastutil.objects.Object2ObjectOpenHashMap;
+
 import java.util.HashMap;
 import java.util.Map;
 
@@ -9,7 +11,7 @@ public abstract class Dispatcher<T, U> {
     protected final Map<T, U> dispatches;
 
     public Dispatcher() {
-        dispatches = new HashMap<>();
+        dispatches = new Object2ObjectOpenHashMap<>();
     }
 
     /**
diff --git a/game/client/src/main/java/net/minecraft/client/world/WorldClient.java b/game/client/src/main/java/net/minecraft/client/world/WorldClient.java
index 3f3239bd4..05b920551 100644
--- a/game/client/src/main/java/net/minecraft/client/world/WorldClient.java
+++ b/game/client/src/main/java/net/minecraft/client/world/WorldClient.java
@@ -1,5 +1,6 @@
 package net.minecraft.client.world;
 
+import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.camera.ICamera;
 import net.minecraft.client.render.colorizer.Colorizers;
@@ -169,4 +170,9 @@ public class WorldClient extends World {
     public int getLightmapCoord(int skyLight, int blockLight) {
         return LightmapHelper.getLightmapCoord(skyLight, blockLight);
     }
+
+    @Override
+    public int renderDistance() {
+        return Minecraft.getMinecraft().gameSettings.renderDistance.value;
+    }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/world/WorldClientMP.java b/game/client/src/main/java/net/minecraft/client/world/WorldClientMP.java
index 82b9e4d56..275f284d6 100644
--- a/game/client/src/main/java/net/minecraft/client/world/WorldClientMP.java
+++ b/game/client/src/main/java/net/minecraft/client/world/WorldClientMP.java
@@ -12,6 +12,7 @@ import net.minecraft.core.world.Dimension;
 import net.minecraft.core.world.chunk.ChunkCoordinates;
 import net.minecraft.core.world.chunk.provider.IChunkProvider;
 import net.minecraft.client.world.save.SaveHandlerClientMP;
+import net.minecraft.core.world.pos.ChunkPos;
 import net.minecraft.core.world.pos.TilePos;
 import org.jetbrains.annotations.NotNull;
 
@@ -125,7 +126,7 @@ public class WorldClientMP extends WorldClient {
             chunkCache.prepareChunk(chunkX, chunkZ);
         } else
         {
-            chunkCache.dropChunk(chunkX, chunkZ);
+            chunkCache.dropChunk(new ChunkPos(chunkX, chunkZ));
         }
         if(!playerAdded)
         {
diff --git a/game/client/src/main/java/net/minecraft/client/world/chunk/provider/ChunkProviderClient.java b/game/client/src/main/java/net/minecraft/client/world/chunk/provider/ChunkProviderClient.java
index dcf3da443..e8671ca22 100644
--- a/game/client/src/main/java/net/minecraft/client/world/chunk/provider/ChunkProviderClient.java
+++ b/game/client/src/main/java/net/minecraft/client/world/chunk/provider/ChunkProviderClient.java
@@ -3,113 +3,97 @@ package net.minecraft.client.world.chunk.provider;
 import net.minecraft.core.world.ProgressListener;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.chunk.Chunk;
-import net.minecraft.core.world.chunk.ChunkCoordinate;
 import net.minecraft.core.world.chunk.EmptyChunk;
 import net.minecraft.core.world.chunk.provider.IChunkProvider;
+import net.minecraft.core.world.pos.ChunkPos;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
 import java.util.*;
 
 public class ChunkProviderClient
-    implements IChunkProvider
-{
-
-    public ChunkProviderClient(World world)
-    {
-        chunkMapping = new HashMap<>();
-        chunks = new ArrayList<>();
-        blankChunk = new EmptyChunk(world, 0, 0);
-        worldObj = world;
+    implements IChunkProvider {
+    private final @NotNull Chunk blankChunk;
+    private final @NotNull Map<ChunkPos, Chunk> chunkMapping;
+    private final @NotNull List<Chunk> chunks;
+    private final @NotNull World worldObj;
+
+
+    public ChunkProviderClient(@NotNull World world) {
+        this.chunkMapping = new HashMap<>();
+        this.chunks = new ArrayList<>();
+        this.blankChunk = new EmptyChunk(world, 0, 0);
+        this.worldObj = world;
     }
 
     @Override
-    public boolean isChunkLoaded(int chunkX, int chunkZ)
-    {
-        return this.chunkMapping.containsKey(new ChunkCoordinate(chunkX, chunkZ));
+    public boolean isChunkLoaded(@NotNull ChunkPos chunkPos) {
+        return this.chunkMapping.containsKey(chunkPos);
     }
 
     @Override
-    public void regenerateChunk(int chunkX, int chunkZ)
-    {
+    public void regenerateChunk(@NotNull ChunkPos chunkPos) {
     }
 
-    public void dropChunk(int chunkX, int chunkZ)
-    {
-        Chunk chunk = provideChunk(chunkX, chunkZ);
-        if(!chunk.isChunkEmpty())
-        {
+    public void dropChunk(@NotNull ChunkPos chunkPos) {
+        Chunk chunk = provideChunk(chunkPos, true);
+        if (!chunk.isChunkEmpty()) {
             chunk.onUnload();
         }
-        chunkMapping.remove(new ChunkCoordinate(chunkX, chunkZ));
-        chunks.remove(chunk);
+        this.chunkMapping.remove(chunkPos);
+        this.chunks.remove(chunk);
     }
 
     @Override
-    public Chunk prepareChunk(int chunkX, int chunkZ)
-    {
-        ChunkCoordinate chunkcoordintpair = new ChunkCoordinate(chunkX, chunkZ);
-        if (chunkMapping.containsKey(chunkcoordintpair)) return chunkMapping.get(chunkcoordintpair);
-        Chunk chunk = new Chunk(worldObj, chunkX, chunkZ);
-        chunkMapping.put(chunkcoordintpair, chunk);
+    public @NotNull Chunk prepareChunk(@NotNull ChunkPos chunkPos, boolean priority) {
+        if (this.chunkMapping.containsKey(chunkPos)) return this.chunkMapping.get(chunkPos);
+        Chunk chunk = new Chunk(this.worldObj, new ChunkPos(chunkPos));
+        this.chunkMapping.put(chunk.pos, chunk);
         chunk.isLoaded = true;
         return chunk;
     }
 
     @Override
-    public Chunk provideChunk(int chunkX, int chunkZ)
-    {
-        ChunkCoordinate coordinate = new ChunkCoordinate(chunkX, chunkZ);
-        Chunk chunk = chunkMapping.get(coordinate);
-        if(chunk == null)
-        {
-            return blankChunk;
-        } else
-        {
+    public @NotNull Chunk provideChunk(@NotNull ChunkPos chunkPos, boolean priority) {
+        Chunk chunk = this.chunkMapping.get(chunkPos);
+        if (chunk == null) {
+            return this.blankChunk;
+        } else {
             return chunk;
         }
     }
 
     @Override
-    public boolean saveChunks(boolean saveImmediately, ProgressListener progressUpdate)
-    {
+    public boolean saveChunks(boolean saveImmediately, @Nullable ProgressListener progressListener) {
 
         return true;
     }
 
     @Override
-    public boolean tick()
-    {
+    public boolean tick() {
         return false;
     }
-    
+
     @Override
-    public void unloadAllChunks()
-	{
-	}
+    public void unloadAllChunks() {
+    }
 
     @Override
-    public boolean canSave()
-    {
+    public boolean canSave() {
         return false;
     }
 
     @Override
-    public void populate(IChunkProvider chunkProvider, int chunkX, int chunkZ)
-    {
+    public void populate(@NotNull ChunkPos chunkPos) {
     }
 
     @Override
-    public String getInfoString()
-    {
-        return "MultiplayerChunkCache: " + chunkMapping.size();
+    public @NotNull String getInfoString() {
+        return "MultiplayerChunkCache: " + this.chunkMapping.size();
     }
 
     @Override
-    public void setCurrentChunkOver(int chunkX, int chunkZ) {
+    public void setCurrentChunkOver(@NotNull ChunkPos chunkPos) {
         // Do nothing
     }
-
-    private final Chunk blankChunk;
-    private final Map<ChunkCoordinate, Chunk> chunkMapping;
-    private final List<Chunk> chunks;
-    private final World worldObj;
 }
